=== modified file 'ChangeLog'
--- ChangeLog	2006-08-09 13:15:41 +0000
+++ ChangeLog	2006-08-09 14:08:12 +0000
@@ -1,8 +1,15 @@
 2006-08-09  Szilveszter Farkas <Szilveszter.Farkas@gmail.com>
 
+    * olive/frontend/gtk/move.py: implemented OliveMove
+    * olive/frontend/gtk/handler.py: added Move signal handler
+    * olive.glade: added Move dialog
+    * olive/backend/errors.py: added NotSameBranchError
+    * olive/backend/fileops.py: added NotBranchError and NotSameBranchError
+      support to move()
     * olive/backend/fileops.py: added NotBranchError support to mkdir()
     * olive/frontend/gtk/mkdir.py: implemented OliveMkdir
     * olive/frontend/gtk/handler.py: added Make directory signal handler
+    * olive.glade: added Make directory dialog
     * olive/backend/update.py: added NotBranchError support to pull()
     * olive/backend/__init__.py: added Branch/Pull signal
     * olive/backend/handler.py: implemented Branch/Pull signal handler

=== modified file 'olive.glade'
--- olive.glade	2006-08-09 13:15:41 +0000
+++ olive.glade	2006-08-09 14:08:12 +0000
@@ -2427,7 +2427,7 @@
   <property name="decorated">True</property>
   <property name="skip_taskbar_hint">False</property>
   <property name="skip_pager_hint">False</property>
-  <property name="type_hint">GDK_WINDOW_TYPE_HINT_NORMAL</property>
+  <property name="type_hint">GDK_WINDOW_TYPE_HINT_DIALOG</property>
   <property name="gravity">GDK_GRAVITY_NORTH_WEST</property>
   <property name="focus_on_map">True</property>
   <property name="urgency_hint">False</property>
@@ -2582,4 +2582,188 @@
   </child>
 </widget>
 
+<widget class="GtkWindow" id="window_move">
+  <property name="width_request">250</property>
+  <property name="visible">True</property>
+  <property name="title" translatable="yes">Olive - Move</property>
+  <property name="type">GTK_WINDOW_TOPLEVEL</property>
+  <property name="window_position">GTK_WIN_POS_NONE</property>
+  <property name="modal">False</property>
+  <property name="resizable">True</property>
+  <property name="destroy_with_parent">False</property>
+  <property name="icon">oliveicon2.png</property>
+  <property name="decorated">True</property>
+  <property name="skip_taskbar_hint">False</property>
+  <property name="skip_pager_hint">False</property>
+  <property name="type_hint">GDK_WINDOW_TYPE_HINT_DIALOG</property>
+  <property name="gravity">GDK_GRAVITY_NORTH_WEST</property>
+  <property name="focus_on_map">True</property>
+  <property name="urgency_hint">False</property>
+
+  <child>
+    <widget class="GtkVBox" id="vbox_move">
+      <property name="border_width">5</property>
+      <property name="visible">True</property>
+      <property name="homogeneous">False</property>
+      <property name="spacing">3</property>
+
+      <child>
+	<widget class="GtkHBox" id="hbox_move">
+	  <property name="visible">True</property>
+	  <property name="homogeneous">False</property>
+	  <property name="spacing">5</property>
+
+	  <child>
+	    <widget class="GtkLabel" id="label_move">
+	      <property name="visible">True</property>
+	      <property name="label" translatable="yes">Move to</property>
+	      <property name="use_underline">False</property>
+	      <property name="use_markup">False</property>
+	      <property name="justify">GTK_JUSTIFY_LEFT</property>
+	      <property name="wrap">False</property>
+	      <property name="selectable">False</property>
+	      <property name="xalign">0.5</property>
+	      <property name="yalign">0.5</property>
+	      <property name="xpad">0</property>
+	      <property name="ypad">0</property>
+	      <property name="ellipsize">PANGO_ELLIPSIZE_NONE</property>
+	      <property name="width_chars">-1</property>
+	      <property name="single_line_mode">False</property>
+	      <property name="angle">0</property>
+	    </widget>
+	    <packing>
+	      <property name="padding">0</property>
+	      <property name="expand">False</property>
+	      <property name="fill">False</property>
+	    </packing>
+	  </child>
+
+	  <child>
+	    <widget class="GtkFileChooserButton" id="filechooserbutton_move">
+	      <property name="visible">True</property>
+	      <property name="title" translatable="yes">Select a directory</property>
+	      <property name="action">GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER</property>
+	      <property name="local_only">True</property>
+	      <property name="show_hidden">False</property>
+	      <property name="do_overwrite_confirmation">False</property>
+	      <property name="width_chars">-1</property>
+	    </widget>
+	    <packing>
+	      <property name="padding">0</property>
+	      <property name="expand">True</property>
+	      <property name="fill">True</property>
+	    </packing>
+	  </child>
+	</widget>
+	<packing>
+	  <property name="padding">0</property>
+	  <property name="expand">True</property>
+	  <property name="fill">True</property>
+	</packing>
+      </child>
+
+      <child>
+	<widget class="GtkHButtonBox" id="hbuttonbox_move">
+	  <property name="visible">True</property>
+	  <property name="layout_style">GTK_BUTTONBOX_SPREAD</property>
+	  <property name="spacing">3</property>
+
+	  <child>
+	    <widget class="GtkButton" id="button_move_move">
+	      <property name="visible">True</property>
+	      <property name="can_default">True</property>
+	      <property name="can_focus">True</property>
+	      <property name="relief">GTK_RELIEF_NORMAL</property>
+	      <property name="focus_on_click">True</property>
+	      <signal name="clicked" handler="on_button_move_move_clicked" last_modification_time="Wed, 09 Aug 2006 13:35:24 GMT"/>
+
+	      <child>
+		<widget class="GtkAlignment" id="alignment9">
+		  <property name="visible">True</property>
+		  <property name="xalign">0.5</property>
+		  <property name="yalign">0.5</property>
+		  <property name="xscale">0</property>
+		  <property name="yscale">0</property>
+		  <property name="top_padding">0</property>
+		  <property name="bottom_padding">0</property>
+		  <property name="left_padding">0</property>
+		  <property name="right_padding">0</property>
+
+		  <child>
+		    <widget class="GtkHBox" id="hbox11">
+		      <property name="visible">True</property>
+		      <property name="homogeneous">False</property>
+		      <property name="spacing">2</property>
+
+		      <child>
+			<widget class="GtkImage" id="image151">
+			  <property name="visible">True</property>
+			  <property name="stock">gtk-apply</property>
+			  <property name="icon_size">4</property>
+			  <property name="xalign">0.5</property>
+			  <property name="yalign">0.5</property>
+			  <property name="xpad">0</property>
+			  <property name="ypad">0</property>
+			</widget>
+			<packing>
+			  <property name="padding">0</property>
+			  <property name="expand">False</property>
+			  <property name="fill">False</property>
+			</packing>
+		      </child>
+
+		      <child>
+			<widget class="GtkLabel" id="label18">
+			  <property name="visible">True</property>
+			  <property name="label" translatable="yes">_Move</property>
+			  <property name="use_underline">True</property>
+			  <property name="use_markup">False</property>
+			  <property name="justify">GTK_JUSTIFY_LEFT</property>
+			  <property name="wrap">False</property>
+			  <property name="selectable">False</property>
+			  <property name="xalign">0.5</property>
+			  <property name="yalign">0.5</property>
+			  <property name="xpad">0</property>
+			  <property name="ypad">0</property>
+			  <property name="ellipsize">PANGO_ELLIPSIZE_NONE</property>
+			  <property name="width_chars">-1</property>
+			  <property name="single_line_mode">False</property>
+			  <property name="angle">0</property>
+			</widget>
+			<packing>
+			  <property name="padding">0</property>
+			  <property name="expand">False</property>
+			  <property name="fill">False</property>
+			</packing>
+		      </child>
+		    </widget>
+		  </child>
+		</widget>
+	      </child>
+	    </widget>
+	  </child>
+
+	  <child>
+	    <widget class="GtkButton" id="button_move_cancel">
+	      <property name="visible">True</property>
+	      <property name="can_default">True</property>
+	      <property name="can_focus">True</property>
+	      <property name="label">gtk-cancel</property>
+	      <property name="use_stock">True</property>
+	      <property name="relief">GTK_RELIEF_NORMAL</property>
+	      <property name="focus_on_click">True</property>
+	      <signal name="clicked" handler="on_button_move_cancel_clicked" last_modification_time="Wed, 09 Aug 2006 13:35:11 GMT"/>
+	    </widget>
+	  </child>
+	</widget>
+	<packing>
+	  <property name="padding">0</property>
+	  <property name="expand">False</property>
+	  <property name="fill">False</property>
+	</packing>
+      </child>
+    </widget>
+  </child>
+</widget>
+
 </glade-interface>

=== modified file 'olive/backend/errors.py'
--- olive/backend/errors.py	2006-07-18 22:21:00 +0000
+++ olive/backend/errors.py	2006-08-09 14:08:12 +0000
@@ -166,6 +166,13 @@
         init.checkout()
     """
 
+class NotSameBranchError(OliveError):
+    """ The specified files are not in the same branch
+    
+    May occur in:
+        fileops.move()
+    """
+
 class NotVersionedError(OliveError):
     """ Occurs if the specified file/directory is not in the branch
     

=== modified file 'olive/backend/fileops.py'
--- olive/backend/fileops.py	2006-08-09 13:15:41 +0000
+++ olive/backend/fileops.py	2006-08-09 14:08:12 +0000
@@ -22,7 +22,8 @@
 
 from errors import (DirectoryAlreadyExists, MissingArgumentError,
                     MultipleMoveError, NoFilesSpecified, NoMatchingFiles,
-                    NonExistingSource, NotBranchError, NotVersionedError)
+                    NonExistingSource, NotBranchError, NotSameBranchError,
+                    NotVersionedError)
 
 def add(file_list, recursive=False):
     """ Add listed files to the branch. 
@@ -77,7 +78,14 @@
     
     if len(names_list) < 2:
         raise MissingArgumentError
-    tree, rel_names = tree_files(names_list)
+    
+    try:
+        tree, rel_names = tree_files(names_list)
+    except errors.NotBranchError:
+        raise NotBranchError
+    except errors.BzrCommandError:
+        # not the same branch presumably
+        raise NotSameBranchError
         
     if os.path.isdir(names_list[-1]):
         # move into existing directory

=== modified file 'olive/frontend/gtk/__init__.py'
--- olive/frontend/gtk/__init__.py	2006-08-09 13:15:41 +0000
+++ olive/frontend/gtk/__init__.py	2006-08-09 14:08:12 +0000
@@ -64,6 +64,8 @@
                 "on_menuitem_add_files_activate": handler.on_menuitem_add_files_activate,
                 "on_menuitem_remove_file_activate": handler.on_menuitem_remove_file_activate,
                 "on_menuitem_file_make_directory_activate": handler.on_menuitem_file_make_directory_activate,
+                "on_menuitem_file_move_activate": handler.on_menuitem_file_move_activate,
+                "on_menuitem_file_rename_activate": handler.not_implemented,
                 "on_menuitem_branch_initialize_activate": handler.on_menuitem_branch_initialize_activate,
                 "on_menuitem_branch_get_activate": handler.on_menuitem_branch_get_activate,
                 "on_menuitem_branch_checkout_activate": handler.on_menuitem_branch_checkout_activate,

=== modified file 'olive/frontend/gtk/handler.py'
--- olive/frontend/gtk/handler.py	2006-08-09 13:15:41 +0000
+++ olive/frontend/gtk/handler.py	2006-08-09 14:08:12 +0000
@@ -118,6 +118,12 @@
         mkdir = OliveMkdir(self.gladefile, self.comm)
         mkdir.display()
     
+    def on_menuitem_file_move_activate(self, widget):
+        """ File/Move... menu handler. """
+        from move import OliveMove
+        move = OliveMove(self.gladefile, self.comm)
+        move.display()
+    
     def on_menuitem_remove_file_activate(self, widget):
         """ Remove (unversion) selected file. """
         from remove import OliveRemove

=== modified file 'olive/frontend/gtk/mkdir.py'
--- olive/frontend/gtk/mkdir.py	2006-08-09 13:15:41 +0000
+++ olive/frontend/gtk/mkdir.py	2006-08-09 14:08:12 +0000
@@ -54,7 +54,7 @@
         self.glade.signal_autoconnect(dic)
 
     def display(self):
-        """ Display the Add file(s) dialog. """
+        """ Display the Make directory dialog. """
         self.window.show_all()
 
     def mkdir(self, widget):

=== added file 'olive/frontend/gtk/move.py'
--- olive/frontend/gtk/move.py	1970-01-01 00:00:00 +0000
+++ olive/frontend/gtk/move.py	2006-08-09 14:08:12 +0000
@@ -0,0 +1,89 @@
+# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+import os
+import sys
+
+try:
+    import pygtk
+    pygtk.require("2.0")
+except:
+    pass
+try:
+    import gtk
+    import gtk.glade
+except:
+    sys.exit(1)
+
+import olive.backend.errors as errors
+import olive.backend.fileops as fileops
+
+from dialog import OliveDialog
+
+class OliveMove:
+    """ Display the Move dialog and perform the needed actions. """
+    def __init__(self, gladefile, comm):
+        """ Initialize the Move dialog. """
+        self.gladefile = gladefile
+        self.glade = gtk.glade.XML(self.gladefile, 'window_move')
+        
+        self.comm = comm
+        
+        self.dialog = OliveDialog(self.gladefile)
+        
+        self.window = self.glade.get_widget('window_move')
+        
+        # Dictionary for signal_autoconnect
+        dic = { "on_button_move_move_clicked": self.move,
+                "on_button_move_cancel_clicked": self.close }
+        
+        # Connect the signals to the handlers
+        self.glade.signal_autoconnect(dic)
+        
+        # Set FileChooser directory
+        self.filechooser = self.glade.get_widget('filechooserbutton_move')
+        self.filechooser.set_filename(self.comm.get_path())
+
+    def display(self):
+        """ Display the Move dialog. """
+        self.window.show_all()
+
+    def move(self, widget):
+        destination = self.filechooser.get_filename()
+
+        filename = self.comm.get_selected_right()
+            
+        if filename is None:
+            self.dialog.error_dialog('No file was selected.')
+            return
+        
+        source = self.comm.get_path() + '/' + filename
+        
+        # Move the file to a directory
+        try:
+            fileops.move([source, destination])
+        except errors.NotBranchError:
+            self.dialog.error_dialog('Selected file is not in a branch.')
+            return
+        except errors.NotSameBranchError:
+            self.dialog.error_dialog('The destination is not in the same branch.')
+            return
+
+        self.close()
+        self.comm.refresh_right()
+    
+    def close(self, widget=None):
+        self.window.destroy()

